package com.maroontress.sanctuary;

import java.io.PrintWriter;
import org.w3c.dom.Element;

/**
   Ǥ

   typedefǤбޤ
*/
public class Typedef {

    /** 롼 */
    private Group group;

    /** ̾ */
    private QualifiedName name;

    /** type° */
    private String type;

    /** descǤ */
    private Description desc;

    /**
       ޤ

       @param g 롼
       @param elem typedef
    */
    public Typedef(final Group g, final Element elem) {
	group = g;
	name = g.expandNS(elem, "name");
	type = g.expandAT(elem, "type");
	g.importTags(type);

	ChildrenFilter c = new ChildrenFilter(elem);
	desc = new Description(g, c.getDirectChildrenByTagName("desc"));
    }

    /**
       ̾ޤ

       @return ̾
    */
    public QualifiedName getName() {
	return name;
    }

    /**
       ɤϤޤ

       @param wr 饤
    */
    public void printCode(final PrintWriter wr) {
	int k = CommentedString.indexOf(type, '#');
	if (k != -1) {
	    wr.println("typedef "
		       + type.substring(0, k)
		       + name
		       + type.substring(k + 1)
		       + ";");
	} else {
	    wr.println("typedef " + type + " " + name + ";");
	}
    }

    /**
       HTMLǽϤޤ

       @param wr 饤
    */
    public void printSummary(final PrintWriter wr) {
	wr.println(""
+ "<tr>\n"
+ "  <td><a href=\"#" + name + "\"><b>" + name.getSimple() + "</b></a><br>"
+ "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"
+ desc.getBriefText() + "</td>\n"
+ "</tr>");
    }

    /**
       ܺ٤HTMLǽϤޤ

       @param wr 饤
    */
    public void printDetail(final PrintWriter wr) {
	wr.print(""
+ "<p><a name=\"" + name + "\"></a>"
+ "<font size=\"+1\"><b>" + name.getSimple() + "</b></font></p>\n"
+ "<dl>\n"
+ "<dd>" + desc.getText() + "</dd>\n"
+ "</dl>");
    }

    /**
       ܺ٤TeXǽϤޤ

       @param wr 饤
    */
    public void printTexDetail(final PrintWriter wr) {
	String typeName = Tex.safe(name.getSimple());
	String ns = group.getPackageName() + "." + group.getName();
	String texLabel = Tex.safeTarget(ns + "." + name);

	wr.println("\\Sid{" + typeName + "}");
	wr.println("\\Slabel{:" + texLabel + ":}");
	wr.println(desc.getTexText());
    }
}
